<?php  // $Id: editobjectives.php,v 1.2 2006/06/26 06:00:37 scarletpumpkin Exp $
    global $CFG;

    require_once("../../config.php");
    require_once("objectives.php");
    $courseid   =  optional_param('id', 0, PARAM_INT);        // Course Module ID
    $fromform   =  optional_param('parent', '', PARAM_NOTAGS);
    $objective  = optional_param('objective', '', PARAM_INT);
    $newobjective = optional_param('newobjective', '', PARAM_NOTAGS);
    $newobjective = trim($newobjective);

    $strnodelete = get_string('nodeleteobjectives', 'teacherplan');
    $strnoadd = get_string('noaddobjectives', 'teacherplan');
    $strnodeletemet = get_string('nodeleteobjectivesmet', 'teacherplan');
    $strnoupdate = get_string('noupdateobjectives', 'teacherplan');
    
    if (optional_param('add', '', PARAM_NOTAGS) !== '') {
        if (!empty($newobjective)) {
            $objectiverecord->course = $courseid;
            $objectiverecord->objective = $newobjective;
            $objectiverecord->timemodified = time();
            if (!insert_record("teacherplan_objectives", $objectiverecord)) {
                error($strnoadd);
            }
        }
    } elseif (optional_param('delete', '', PARAM_NOTAGS) !== '') {
        if (!delete_records("teacherplan_objectives", "id", $objective)) {
          error($strnodelete);
        }

        if (!delete_records_select("teacherplan_objectives_met", "objectiveid=".$objective)) {
          error($strnodeletemet);
        }
    } elseif (optional_param('replace', '', PARAM_NOTAGS) !== '') {
        $objectiverecord->course = $courseid;
        $objectiverecord->id = $objective;
        $objectiverecord->objective = $newobjective;
        $objectiverecord->timemodified = time();

        if (!update_record("teacherplan_objectives", $objectiverecord)) {
           error($strnoupdate);
        }
    } else {
        add_to_log($courseid, "teacherplan", "view objectives", "editobjectives.php?id={$courseid}");
    }
?>
<script language="JavaScript" type="text/javascript">
<!--
function selectFromList()
{
  var df = document.forms.modform;
  df.newobjective.value = df.objective.options[df.objective.selectedIndex].text;
}

function updateAndClose() 
{
    if (<?php if (empty($fromform)){echo "true";}else{echo "false";} ?>) {
        opener.location.reload(true);
    } else {
        opener.updateObjectives(document.forms.modform.objective, <?php echo $fromform.'[]' ?>);
    }
    self.close();
}
--></script>
<?PHP
//print the form   
    print_header();
?>
    <p align="right"><a href="configobjectives.php?id='.$courseid.'&parent='.$fromform.'"><?php print_string('configobjimpobjectivestitle', 'teacherplan') ?></a></p>
    <form name="modform" action=<?php echo "$CFG->wwwroot/mod/teacherplan/editobjectives.php" ?> >
    <input type="hidden" name="id"       value="<?php echo $courseid ?>" />
    <input type="hidden" name="parent"         value="<?php echo $fromform ?>" />

    <table width="600" cellpadding="5">
    <tr valign="top"><td colspan=2>
<?php
    print_objectives_selectbox($courseid, 0, "objective", false, "return selectFromList()");
?>
    </td></tr>
    <tr valign="top"><td>
    <input type="submit" name="delete" value="<?php print_string('deleteobjectivestexttitle', 'teacherplan')?>"><br><br>
    <?php print_string('objectivelabel', 'teacherplan') ?>:
    <input type="text" name="newobjective" value="" size="85" maxlength="255"><br>
    <input type="submit" name="add" value="<?php print_string('addobjectivestexttitle', 'teacherplan') ?>">&nbsp;&nbsp;&nbsp;
    <input type="submit" name="replace" value="<?php print_string('replaceobjectivestexttitle', 'teacherplan') ?>"><br>
    </td></tr></table>
    </form>
    <center><input type="button" onClick="return updateAndClose()" value="<?php print_string('returnfromobjectives', 'teacherplan') ?>"></center>
    <br>