<?php // $Id: search.php,v 1.1 2006/06/23 18:28:24 scarletpumpkin Exp $

    require_once("../../config.php");
    require_once("lib.php");
    global $CFG;

    $searchstr = '';

//passed params
    $teacherid = optional_param('teacher', '', PARAM_NOTAGS);
    $searchstr .= "teacher=$teacherid&";
    $searchform->teacher = $teacherid;
    $courseid = optional_param('courseid', '', PARAM_NOTAGS);
    $searchstr .= "courseid=$courseid&";
    $searchform->courseid = $courseid;
    $planstr = optional_param('plandata', '', PARAM_NOTAGS);
    $searchstr .= "plandata=$planstr&";
    $searchform->plandata = $planstr;
    $includeassgn = optional_param('incasgn', false, PARAM_BOOL);
    $searchstr .= $includeassgn ?"incasgn=yes&":"";
    $searchform->includeassignments = $includeassgn;
    $today = optional_param('today', '0', PARAM_INT);
    $searchstr .= "today=$today&";
    $searchform->today = $today;
    $tomonth = optional_param('tomonth', '0', PARAM_INT);
    $searchstr .= "tomonth=$tomonth&";
    $searchform->tomonth = $tomonth;
    $toyear = optional_param('toyear', '0', PARAM_INT);
    $searchstr .= "toyear=$toyear&";
    $searchform->toyear = $toyear;
    $todate = make_timestamp($toyear, $tomonth, $today, 0, 0);
    $fromday = optional_param('fromday', '0', PARAM_INT);
    $searchstr .= "fromday=$fromday&";
    $searchform->fromday = $fromday;
    $frommonth = optional_param('frommonth', '0', PARAM_INT);
    $searchstr .= "frommonth=$frommonth&";
    $searchform->frommonth = $frommonth;
    $fromyear = optional_param('fromyear', '0', PARAM_INT);
    $searchstr .= "fromyear=$fromyear&";
    $searchform->fromyear = $fromyear;
    $fromdate = make_timestamp($fromyear, $frommonth, $fromday, 0, 0);
    $perpage = optional_param('maxtosee', '10', PARAM_INT);
    $searchstr .= "maxtosee=$maxtosee&";
    $searchform->maxtosee = $maxtosee;
    $page = optional_param('page', '0', PARAM_INT);
    $printable = optional_param('printable', 'no', PARAM_ALPHA) == "yes";

//translated strings
    $strteacherplan = get_string("modulename", "teacherplan");
    $strteacherplans = get_string("modulenameplural", "teacherplan");
    $strobjectives = get_string("objectivestexttitle", "teacherplan");
    $strplan = get_string("plantexttitle", "teacherplan");
    $strneedparams = get_string("searchneedsparams", "teacherplan");
    $strplansearch = get_string('searchtitle', 'teacherplan');
    $strsearchresults = get_string("searchresultstitle", "teacherplan");
    $strunknowncourse = get_string('courseunknown', 'teacherplan');
    $strnomatchingplans = get_string('nomatchingplans', 'teacherplan');
    $searchbtnstr = get_string('searchagainbtntext', 'teacherplan');
    $strassignments = get_string('modulenameplural', 'assignment');
    $strduedate = get_string('duedate', 'assignment');
    $strassessment = get_string('assessmenttitle', 'teacherplan');
    $strnoassessment = get_string('noassessment', 'teacherplan');
    $strprintableiconyes = '<img src="printview.gif" />'.get_string('printabletextyes', 'teacherplan');
    $strprintableiconno = '<img src="searchview.gif" />'.get_string('printabletextno', 'teacherplan');
    $strmultidaylabel = get_string('multidaysearchlabel', 'teacherplan');

    if (!empty($CFG->forcelogin)) {
        require_login();
    }

//Assignment sql starter
    $assignmentsql = "SELECT * FROM ".$CFG->prefix."assignment WHERE course=";

//Teacher search
    $teachlist = '';
    $teachernotfound = false;
    if (!empty($teacherid)) {
        $teacheridarray = explode(",", $teacherid);
        foreach ($teacheridarray as $teachername) {
            if ($teachersfoundlist = get_records_select("user", "concat(lastname, \" \",firstname) LIKE '%$teachername%'")) {
                foreach ($teachersfoundlist as $found) {
                    if ($courselist = get_records("user_teachers", "userid", $found->id)) {
                        foreach ($courselist as $coursefound) {
                            if (empty($teachlist)) {
                                $teachlist = $coursefound->course;
                            } else {
                                $teachlist .= ','.$coursefound->course;
                            }
                        }
                    }
                }
            }
        }
        if (empty($teachlist)) {
            $teachernotfound = true;
        } 
    }    

//Courses search
    $courselist = '';
    $coursenotfound = false;
    if (!empty($courseid)) {
        $coursesarray = explode(",", $courseid);
        foreach ($coursesarray as $coursename) {
            if ($coursesfoundlist = get_records_select("course", "fullname LIKE '%$coursename%'", "", "id,fullname")) {
                foreach ($coursesfoundlist as $found) {
                    if (empty($courselist)) {
                        $courselist = $found->id;
                    } else {
                        $courselist .= ','.$found->id;
                    }
                    $coursematch[$found->id] = $found->fullname;
                }
            }
        } 
        if (empty($courselist)) {
            $coursenotfound = true;
        } 
    }    

//Handle left-off parameters
   $notfound = false;
   if (empty($teachlist) AND !$teachernotfound) {
       $teachlist = $courselist;
   } else if (empty($courselist) AND !$coursenotfound) {
       $courselist = $teachlist;
   } else if ($coursenotfound OR $teachernotfound) {
       $notfound = true; //Both lists are empty with data specified
   }
//combine
    $teacherarray = explode(",", $teachlist);
    $stuffer = '';
    if ($teacherarray) {
        foreach ($teacherarray as $teachercourseid) {
            if (strpos(",".$courselist.",".$stuffer.",", ",".$teachercourseid.",") !== false) {
                if (empty($stuffer)) {
                    $stuffer = $teachercourseid;
                } else {
                    $stuffer .= ','.$teachercourseid;
                }
            }
        }
    }

    if ($printable) {
        print_header_simple("", "", $strteacherplans, "", "", "", "", "");
    } else {
        $searchlink = me();
        $searchlink = str_ireplace("/moodle/", "/", $searchlink);
        $printableicon =  "<a title=\"".$strteacherplans."\" target=\"printwindow\" ";
        $printableicon .= "onclick=\"return openpopup('".$searchlink."&printable=yes', 'printwindow', ";
        $printableicon .= "'menubar=1,height=400,width=620,resizable=1', false);\" href=\"".me()."&printable=yes\">";
        $printableicon .= $strprintableiconyes."</a>";
        print_header_simple($strplansearch, "", $strteacherplans, "", "", "", "", $printableicon);
    }
    
    if (!empty($stuffer)) {
        $stuffer = 'course IN ('.$stuffer.') AND ';
    }

//Plan information
    if (!empty($planstr)) {
        $plandataarray = explode(",", $planstr);
        $plandatasql = " (plan LIKE '%".implode("%' OR plan LIKE '%", $plandataarray)."%') AND ";
    }

// Prepare search string
    $sqlsearch = 'FROM '.$CFG->prefix.'teacherplan WHERE '.$stuffer.$plandatasql;

    $datestr = '';
    if ($todate !== 0) {
        $datestr = 'plandate <= '.$todate;
    }

    if ($fromdate !== 0) {
        if (empty($datestr)) {
            $datestr = '(plandate >= '.$fromdate.' OR (multiday AND planenddate >= '.$fromdate.'))';
        } else {
            $datestr = '('.$datestr.' AND (plandate >= '.$fromdate.' OR (multiday AND planenddate >='.$fromdate.')))';
        }
    }

    $sqlsearch .= $datestr;

    if ($notfound) {
        $totalcount = 0;
    } else {
        $totalcount = count_records_sql("SELECT COUNT(*) $sqlsearch");
    }
    
    $sqlsearch .= ' ORDER BY plandate,period,course ASC LIMIT '.$page*$perpage.','.$perpage;
    
    if (!$printable) {    
        echo '<table width="100%" border=0><tr><td width="33%">&nbsp;</td>';
        echo '<td width="33%" align="center"><h2>'.$strsearchresults.': '.$totalcount.'</td>';
        echo '<td width="33%" align="right"><a href="#search">Change Search</a></td></tr></table>';
    
        if ($totalcount > $perpage) {
            print_paging_bar($totalcount, $page, $perpage, "search.php?$searchstr");
        }
    }

    $options->para = false;

    if (!$notfound AND $teacherplans = get_records_sql("SELECT * $sqlsearch")) {
        foreach ($teacherplans as $teacherplan) {
            if ($currentdate !== $teacherplan->plandate) {
                $currentdate = $teacherplan->plandate;
                $showdate = userdate($currentdate, "%m/%d/%y (%a)");
                $table->data[] = 'hr';
            } else {
                $showdate = '&nbsp;';
            }

            if (empty($coursematch[$teacherplan->course])) {
                if ($courserec = get_record('course', 'id', $teacherplan->course)) {
                    $coursematch[$courserec->id] = $courserec->fullname;
                } else {
                    $coursematch[$courserec->id] = $strunknowncourse;
                }
            }

            $plantext  = '<center><h3>'.$coursematch[$teacherplan->course].'</h3></center>';
            //Handle multiday plans with ease
            if ($teacherplan->multiday) {
                $plantext .= '<br><center><h5><i>'.$strmultidaylabel;
                $plantext .= userdate($teacherplan->enddate, "%m/%d/%y (%a)").'</i></h5>';
            }
            $plantext .= '<table border="1" cellpadding="2" cellspacing="0">';
            $plantext .= '<tr><td valign="top"><font size=+1><b>';
            $plantext .= $strobjectives;
            $plantext .= '</b></font></td><td>';
 
            if (! $objectivestext = teacherplan_get_objectives_string($teacherplan->id, $teacherplan->course)) {
                $objectivestext = get_string("noobjectivesgiven", "teacherplan");
            } else {
                $objectivestexttemp = "<ul><li>".implode("<li>", $objectivestext)."</ul>";
                unset($objectivestext);
                $objectivestext = $objectivestexttemp;
            }

            $plantext .= $objectivestext;
            $plantext .= '</td></tr><tr><td valign="top"><font size=+1><b>';
            $plantext .= $strplan;
            $plantext .= '</b></font></td><td>';
            $plantext .= format_text($teacherplan->plan, FORMAT_HTML, $options);
            $plantext .= '</td></tr>';

            $plantext .= '<tr><td valign="top"><font size=+1><b>';
            $plantext .= $strassessment;
            $plantext .= '</b></font></td><td>';
            $assesstext = format_text($teacherplan->assessment, FORMAT_HTML, $options);
            if (empty($assesstext)) {
                $assesstext = "<i>".$strnoassessment."</i>";
            }
            $plantext .= $assesstext;
            $plantext .= '</td></tr>';
            
//Show assignments to be shown on this day
            if ($includeassgn) {
                $plantext .= '<tr><td><font size =+1><b>';
                $plantext .= $strassignments;
                $plantext .= '</b></font></td><td>';

                $thisassgnsql = $assignmentsql.$teacherplan->course." AND timeavailable >= ";
                $thisassgnsql .= $currentdate." AND timeavailable < ".($currentdate+86400);
                 
                if ($assgnlist = get_records_sql($thisassgnsql)) {
                    foreach ($assgnlist as $assignment) {
                        if (isset($assgnhrule)) {
                            $plantext .= $assgnhrule;
                        }
                        $assgnhrule = '<hr>';
                        $plantext .= '<font size=-1><u>'.$assignment->name.'</u><br>';
                        $plantext .= '&nbsp;&nbsp;'.format_text($assignment->description, FORMAT_HTML, $options).'<br>';
                        $plantext .= '&nbsp;&nbsp;<i>'.$strduedate.': ';
                        $plantext .= userdate($assignment->timedue).'</i></font>';
                    }
                    unset($assgnhrule);
                } else {
                    $plantext .= '<i>'.get_string('nonewassignmentstoday', 'teacherplan').'</i>';
                } 
                $plantext .= '</td></tr>';
            }

            $plantext .= '</table>';

            $table->data[] = array($showdate, $plantext);
            
        }

        if (!empty($table)) {
            $table->head  = array (get_string('date'), $strteacherplans);
            $table->align = array ("left", "left");
            $table->width = '90%';
            print_table($table);
        }

        if ($totalcount > $perpage AND !$printable) {
            print_paging_bar($totalcount, $page, $perpage, "search.php?$searchstr");
        }
    } else {
        echo "<center>".$strnomatchingplans."</center><br />";
    }

    if ($printable) {   
        close_window_button();
    } else { 
        echo "<br /><a name=\"search\"></a>";
        echo teacherplan_search_form(false, "search", "$searchbtnstr >>", $searchform);

        print_footer();
    }
?>

