<?php 
    global $CFG;

    require_once("../../config.php");
    $courseid   =  optional_param('id', 0, PARAM_INT);        // Course Module ID
    $fromform   =  optional_param('parent', '', PARAM_NOTAGS);
    $coursepar  =  optional_param('par', '', PARAM_NOTAGS);
    $impfromcourse  =  optional_param('impcourse', '', PARAM_INT);
    if (empty($impfromcourse)) {
        $impfromcourse  =  optional_param('impcoursehid', '', PARAM_INT);
    }
    $impobjs = optional_param('impobjs', '', PARAM_ALPHA);      

    $strnoupdate = get_string('noupdateobjectives', 'teacherplan');

    $done = false;

    if (!empty($impfromcourse) and !empty($impobjs) and !empty($courseid)) {
        if ($impobjectives = get_records_select('teacherplan_objectives', 'course='.$impfromcourse, "", "*")) {
            foreach ($impobjectives as $newobjective) {
                $objective->course = $courseid;
                $objective->objective = addslashes($newobjective->objective);
                $objective->timemodified = time();
                if (!insert_record("teacherplan_objectives", $objective)) {
                    error($strnoupdate);
                }
            }
            $done = true;
        }
    }
    
?>
<?php    if ($done) { ?>
<script language="JavaScript" type="text/javascript">
<!--
    self.location.replace("editobjectives.php?id=<?php echo $courseid ?>&parent=<?php echo $fromform ?>");
-->
</script>
<?php } else { ?>
<p align="right"><a href="editobjectives.php?id=<?php echo $courseid ?>&parent=<?php echo $fromform ?>"><?php print_string('editobjimpobjectivesreturn', 'teacherplan') ?></a></p>
<form name="cfgform" action="<?php echo $CFG->wwwroot.'/mod/teacherplan/configobjectives.php' ?>">
<input type="hidden" name="id" value="<?php echo $courseid ?>" />
<input type="hidden" name="parent" value="<?php echo $fromform ?>" />
<input type="hidden" name="impcoursehid" value="<?php echo $impfromcourse ?>" />
<table cellpadding=2 cellspacing=1 border=1>
<tr>
<th align="center"><?php print_string('configobjfromcoursetitle', 'teacherplan') ?></th>
<th align="center"><?php print_string('configobjimpobjectivestitle', 'teacherplan') ?></th>
</tr>
<tr>
<td>
<select name=impcourse style="width: 200px" id=impcourse size=10>
<?php
    $fieldsearch = '';
    if (!empty($coursepar)) {
        $fieldsearch = "fullname LIKE '%".$coursepar."%' OR shortname LIKE '%".$coursepar."%'";
    }
    $courses = get_records_select('course', $fieldsearch, "fullname", "id,fullname,shortname");
    
    if (!empty($courses)) {
        foreach ($courses as $acourse) {
            echo '<option value="'.$acourse->id.'">'.$acourse->fullname.':'.$acourse->shortname.'</option>';
        }
    }
?>
</select>
</td>
<td>
<select name=newobjlist style="width: 400px" id=newobjlist size=10>
<?php
    if (!empty($impfromcourse)) {
        if ($objectives = get_records_select('teacherplan_objectives', 'course='.$impfromcourse, "objective", "id,objective")) {
            foreach ($objectives as $anobjective) {
                echo '<option value="'.$anobjective->id.'">'.$anobjective->objective.'</option>';
            }
        }
    } 
?>
</select>
</td>
</tr>
<tr>
<td>
<input type="submit" name="searchcourse" value="<?php print_string('searchcourse', 'teacherplan') ?>" >
<input type="text" name="par" value="" size=10><br>
<center>
<input type="submit" name="impcoursebtn" value="<?php print_string('fromthiscourse', 'teacherplan') ?>" >
</center>
</td>
<td align="center">
<input type="submit" name="impobjs" value="<?php print_string('imptheseobjs', 'teacherplan') ?>" >
</td>
</tr></table>
</form>
<?php } /*end the else of $done*/ ?>