<?php // $Id: mysql.php,v 1.3 2006/07/13 13:06:11 scarletpumpkin Exp $

function teacherplan_upgrade($oldversion) {
/// This function does anything necessary to upgrade 
/// older versions to match current functionality 

    global $CFG;

    if ($oldversion < 2006011810) {
        execute_sql(" ALTER TABLE {$CFG->prefix}teacherplan ADD `plandate` INT(10) UNSIGNED NOT NULL AFTER `plan` "); 
    }

    if ($oldversion < 2006012820) {
        execute_sql(" ALTER TABLE {$CFG->prefix}teacherplan ADD `period` int(2) NOT NULL default '1' AFTER `plan` "); 
        execute_sql(" ALTER TABLE {$CFG->prefix}teacherplan ADD `assessment` text NULL AFTER `plan` "); 
    }
    
    if ($oldversion < 2006030110) {
        execute_sql(" ALTER TABLE {$CFG->prefix}teacherplan ADD `multiday` tinyint(1) unsigned NOT NULL default '0' AFTER `plandate` ");
        execute_sql(" ALTER TABLE {$CFG->prefix}teacherplan ADD `planenddate` int(10) unsigned NOT NULL default '0' AFTER `multiday` ");
    }
   
    if ($oldversion < 2006070210) {
        execute_sql(" ALTER TABLE {$CFG->prefix}teacherplan ADD `materials` text NULL AFTER `assessment` ");
        execute_sql(" ALTER TABLE {$CFG->prefix}teacherplan_objectives ADD `standardid` int(10) unsigned NOT NULL default '0' AFTER `name` ");

        execute_sql(" CREATE TABLE {$CFG->prefix}teacherplan_standards (
                                    id int(10) unsigned NOT NULL auto_increment,
                                    course int(10) unsigned NOT NULL default '0',
                                    name varchar(255) NOT NULL default '',
                                    standard varchar(255) NOT NULL default '',
                                    timemodified int(10) unsigned NOT NULL default '0',
                                    PRIMARY KEY (id),
                                    UNIQUE KEY `id` (`id`),
                                    KEY `course` (`course`)
                                    ) TYPE=MyISAM; ");
    }
                                                                          
    if ($oldversion < 2006071240) {
        execute_sql(" ALTER TABLE {$CFG->prefix}teacherplan_standards ADD `parentid` int (10) unsigned default NULL AFTER `standard` ");
    }
    
    return true;
}

?>
