# phpMyAdmin MySQL-Dump
# version 2.2.1
# http://phpwizard.net/phpMyAdmin/
# http://phpmyadmin.sourceforge.net/ (download page)
#
# Host: localhost
# Generation Time: Nov 14, 2001 at 04:43 PM
# Server version: 3.23.36
# PHP Version: 4.0.6
# Database : `moodle`
# --------------------------------------------------------

#
# Table structure for table `teacherplan`
#
# For the plans themselves
CREATE TABLE prefix_teacherplan (

  id int(10) unsigned NOT NULL auto_increment,
  course int(10) unsigned NOT NULL default '0',
  name varchar(255) NOT NULL default '',
  plan text NOT NULL,
  assessment text NULL,
  materials text NULL,
  period int(2) unsigned NOT NULL default '1',
  plandate int(10) unsigned NOT NULL default '0',
  multiday tinyint(1) unsigned NOT NULL default '0',
  planenddate int(10) unsigned NOT NULL default '0',
  timemodified int(10) unsigned NOT NULL default '0',

  PRIMARY KEY  (id),
  UNIQUE KEY `id` (`id`),
  KEY `course` (`course`)

) TYPE=MyISAM;

#
# Table of benchmarks to be met during this course
#  (maintained separate from the plans themselves, although
#   they are connected to the plans through another table)
#
CREATE TABLE prefix_teacherplan_objectives (

  id int(10) unsigned NOT NULL auto_increment,
  course int(10) unsigned NOT NULL default '0',
  name varchar(255) NOT NULL default '',
  standardid int(10) unsigned NOT NULL default '0',
  objective varchar(255) NOT NULL default '',
  timemodified int(10) unsigned NOT NULL default '0',

  PRIMARY KEY (id),
  UNIQUE KEY `id` (`id`),
  KEY `course` (`course`)

) TYPE=MyISAM;

#
# Table of standards to be met during this course
#  (maintained separate from the plans themselves, although
#   they are connected to the plans through another table)
#
CREATE TABLE prefix_teacherplan_standards (

  id int(10) unsigned NOT NULL auto_increment,
  course int(10) unsigned NOT NULL default '0',
  name varchar(255) NOT NULL default '',
  standard varchar(255) NOT NULL default '',
  parentid int(10) unsigned default NULL,
  timemodified int(10) unsigned NOT NULL default '0',

  PRIMARY KEY (id),
  UNIQUE KEY `id` (`id`),
  KEY `course` (`course`)

) TYPE=MyISAM;

#
# Table of (plan, objective) pairs to connect the plans
# to the objectives they meet
#
CREATE TABLE prefix_teacherplan_objectives_met (

  id int(10) unsigned NOT NULL auto_increment,
  course int(10) unsigned NOT NULL default '0',
  planid int(10) unsigned NOT NULL default '0',
  objectiveid int(10) unsigned NOT NULL default '0',
  timemodified int(10) unsigned NOT NULL default '0',

  PRIMARY KEY  (id),
  UNIQUE KEY `id` (`id`),
  KEY  `planid` (planid),
  KEY `objectiveid` (objectiveid),
  KEY `course` (`course`)

) TYPE=MyISAM;

#
# Dumping data for table `log_display`
#

INSERT INTO prefix_log_display (module, action, mtable, field) VALUES ('teacherplan', 'view', 'teacherplan', 'name');
INSERT INTO prefix_log_display (module, action, mtable, field) VALUES ('teacherplan', 'update', 'teacherplan', 'name');
INSERT INTO prefix_log_display (module, action, mtable, field) VALUES ('teacherplan', 'add', 'teacherplan', 'name');
INSERT INTO prefix_log_display (module, action, mtable, field) VALUES ('teacherplan', 'view objectives', 'teacherplan', 'name');
INSERT INTO prefix_log_display (module, action, mtable, field) VALUES ('teacherplan', 'update objectives', 'teacherplan', 'name');
INSERT INTO prefix_log_display (module, action, mtable, field) VALUES ('teacherplan', 'add objectives', 'teacherplan', 'name');
