<?php // $Id: index.php,v 1.3 2006/07/13 13:05:22 scarletpumpkin Exp $

    require_once("../../config.php");
    require_once("lib.php");

    $id = required_param('id');   // course
    $viewby = optional_param('viewby', 'plan', PARAM_ALPHA);    // View type

    if (!empty($CFG->forcelogin)) {
        require_login();
    }

    if (! $course = get_record('course', 'id', $id)) {
        error('Course ID is incorrect');
    }

    if ($course->category) {
        require_login($course->id);
        $navigation = '<a href="../../course/view.php?id='.$course->id.'">'.$course->shortname.'</a> ->';
    } else {
        $navigation = '';
    }
    add_to_log($course->id, 'teacherplan', 'view all', 'index.php?id='.$course->id, '');

    $strteacherplan = get_string('modulename', 'teacherplan');
    $strteacherplans = get_string('modulenameplural', 'teacherplan');
    $strweek = get_string('week');
    $strtopic = get_string('topic');
    $strname = get_string('name');
    $strobjectives = get_string('objectivestexttitle', 'teacherplan');
    $strstandards = get_string('standardstexttitle', 'teacherplan');
    $strplan = get_string('plantexttitle', 'teacherplan');
    $strlastmodified = get_string('lastmodified');
    $strviewby = get_string('viewby', 'teacherplan');
    $strplans = get_string('plantextstitle', 'teacherplan');

    print_header("$course->shortname: $strteacherplans", $course->fullname, "$navigation $strteacherplans", 
                 '', '', true, teacherplan_viewobjectives_link($course->id), navmenu($course));
    echo '<table cellpadding="2" border="0" cellspacing="1"><tr>';
    echo '<td width="85%" align="center" valign="top">';
    echo '<b>'.$strviewby.':&nbsp;&nbsp;<a href="'.me().'&viewby=plan">';
    echo $strplans.'</a>&nbsp;&nbsp;&nbsp;';
    echo '<a href="'.me().'&viewby=objective">'.$strstandards.'/'.$strobjectives.'</a></b>';
    echo '</td><td width="15%" align="right">';
    echo teacherplan_editobjectives_link($course->id);
    echo '</td></tr></table>';
    echo '<br />';

    $simple_box_start_tags = '<table class="generalbox" border="0" cellpadding="2" cellspacing="0">';
    $simple_box_start_tags .= '<tr><td class="generalboxcontent">';
    $simple_box_end_tags = '</td></tr></table>';

    if ($viewby == 'objective') {
        echo teacherplan_get_pretty_objectives(-1, $course->id, false, 'teacherplan_index_callback_print_met');
/*        if (! $objectives = get_records('teacherplan_objectives', 'course', $course->id, 'standardid, name,objective')) {
            notice(get_string('noobjectivesgivenanywhere', 'teacherplan'), '../../course/view.php?id='.$course->id.'?&viewby=objective');
            exit;
        }
        $currentobjsection = 0;
        $currentstandsection = 0;
        $options->para = false;
    
        if ($course->format == 'weeks') {
            $sectionname=$strweek;
        } else if ($course->format == 'topics') {
            $sectionname=$strtopic;
        } else {
            $sectionname=$strlastmodified;
        }

        $table->head  = array (get_string('standardstexttitle', 'teacherplan'), get_string('objectivestexttitle', 'teacherplan'), get_string('plansmetheader', 'teacherplan'));
        $table->align = array ('left', 'left', 'left');

        $strnostandard = get_string('nostandardselected', 'teacherplan');
        foreach ($objectives as $objective) {
            $standardtext = '';
            if ($objective->standardid !== $currentstandsection) {
                if ($currentstandsection !== 0) {
                    $table->data[] = 'hr';
                }
                $currentstandsection = $objective->standardid;  
                $standardtext = $strnostandard;
                if ($standard = get_record('teacherplan_standards', 'id', $objective->standardid)) {
                    $standardtext  = '<b>'.$standard->name.'</b>&nbsp;'.$standard->standard;
                    $standardtext = format_text($standardtext, FORMAT_MOODLE, NULL, $course->id); 
                }    
            }
            
            if ($objective->id !== $currentobjsection) {
                $currentobjsection = $objective->id;
                $objectivetext  = '<b>'.$objective->name.'</b>&nbsp;'.$objective->objective;
                $objectivetext = format_text($objectivetext, FORMAT_MOODLE, NULL, $course->id); 
            }
            }
                 
            $table->data[] = 
                array ($standardtext, $objectivetext, $planlist);
        } */
    } else {
        if (! $teacherplans = get_all_instances_in_course('teacherplan', $course)) {
            notice(get_string('noplansexist', 'teacherplan'), '../../course/view.php?id='.$course->id.'&viewby=plan');
            exit;
        }

        if ($course->format == 'weeks') {
            $table->head  = array ($strweek, $strname, $strobjectives, $strplan);
            $table->align = array ('center', 'left', 'left', 'left');
        } else if ($course->format == 'topics') {
            $table->head  = array ($strtopic, $strname, $strobjectives, $strplan);
            $table->align = array ('center', 'left', 'left', 'left');
        } else {
            $table->head  = array ($strlastmodified, $strname, $strobjectives, $strplan);
            $table->align = array ('left', 'left', 'left', 'left');
        }

        $currentsection = '';
        $options->para = false;
    
        foreach ($teacherplans as $teacherplan) {
            if ($course->format == 'weeks' or $course->format == 'topics') {
                $printsection = '';
                if ($teacherplan->section !== $currentsection) {
                    if ($teacherplan->section) {
                        $printsection = $teacherplan->section;
                    }
                    if ($currentsection !== '') {
                        $table->data[] = 'hr';
                    }
                    $currentsection = $teacherplan->section;
                }
            } else {
                $printsection = '<span class="smallinfo">'.userdate($teacherplan->timemodified).'</span>';
            }
    
            $dimmedtag = '';
            if (!$teacherplan->visible) {      // Show dimmed if the mod is hidden
                $dimmedtag = 'class="dimmed"';
            }
    
            $objectivestext = teacherplan_get_objectives_string($teacherplan->id, $teacherplan->course);
    
            if (!$objectivestext) {
                $objectivestext = get_string('noobjectivesgiven', 'teacherplan');
            } else {
                $objectivestexttemp = '<ul><li>'.implode('<li>', $objectivestext).'</ul>';
                unset($objectivestext);
                $objectivestext = format_text($objectivestexttemp, FORMAT_MOODLE, NULL, $course->id);
            }
            $viewupdate = '<a '.$dimmedtag.' href="view.php?id='.$teacherplan->coursemodule.'">';
            $viewupdate .= 'View '.format_string($teacherplan->name,true).'</a><br>';
            $viewupdate .= update_module_button($teacherplan->coursemodule, $teacherplan->course, '');

            $assesstext = format_text($teacherplan->assessment, FORMAT_HTML, $options); 
            if (empty($assesstext)) {
                $assesstext = '<i>'.get_string('noassessment', 'teacherplan').'</i>';
            }
            $plantext  = $simple_box_start_tags;
            $plantext .= format_text($teacherplan->plan, FORMAT_MOODLE, $options);
            $plantext .= '<p align="center"><i><font size="2"><b>';
            $plantext .= get_string('assessmenttitle', 'teacherplan').'</b><br>';
            $plantext .= $assesstext.'</font></i>';
            $plantext .= $simple_box_end_tags;
            
            $table->data[] = 
                array ($printsection, 
                $viewupdate,
                '<font size="2"><i>'.$objectivestext.'</i></font>',
                $plantext);

        }
        print_table($table);
    }

    print_footer($course);
 
function teacherplan_index_callback_print_met($benchmarkid) {

    $planlist = '';
    $objectivesmet = get_records('teacherplan_objectives_met', 'objectiveid', $benchmarkid);
    if (!$objectivesmet) {      
        $planlist .= '<font color=#999999>'.get_string('noplansmeetobjective', 'teacherplan').'</font>';
    } else {
        foreach ($objectivesmet as $met) {
            $planlist .= '<li>';
            
            if ($plan = get_record('teacherplan', 'id', $met->planid)) {
                $planlist .= '<a href="view.php?tp='.$plan->id.'">'.$plan->name;
                if ($plan->plandate == 0) {
                    $planlist .= '(<i>No date given</i>)</a>';
                } else {
                    $planlist .= '('.userdate($plan->plandate, '%m/%d/%y');
                    if ($plan->multiday) {
                        $planlist .= ' - '.userdate($plan->planenddate, '%m/%d/%y');
                    }
                    $planlist .= ')</a>';
                }
            } else {
                $planlist .= '<font color=#FF0000>'.get_string('errteacherplanidincorrect', 'teacherplan');
                $planlist .= '</font>';
            }
        }
    }
    return '<ul>'.$planlist.'</ul>';
}
?>

